<?
/**
 * Samurai_Restful_Action.abstract
 * 
 * RESTfulAction抽象クラス。
 * RESTfulなアプリケーションを作成したい際に継承してください。
 * 
 * @package    Samurai
 * @subpackage Samurai
 * @copyright  Befool, Inc
 * @author     Satoshi Kiuchi <samurai@don-quijote.jp>
 * @license    http://opensource.org/licenses/bsd-license.php  The modified BSD License
 */
class Samurai_Restful_Action extends Samurai_Action
{
    /**
     * コンストラクタ。
     * @access     public
     */
    public function __construct()
    {
        
    }
    
    
    /**
     * GETメソッド時に実行される。
     * @access     public
     */
    public function GET()
    {
        Samurai_Logger::debug('Executed Action::GET. -> %s', get_class($this));
    }
    
    /**
     * POSTメソッド時に実行される。
     * @access     public
     */
    public function POST()
    {
        Samurai_Logger::debug('Executed Action::POST. -> %s', get_class($this));
    }
    
    /**
     * PUTメソッド時に実行される。
     * @access     public
     */
    public function PUT()
    {
        Samurai_Logger::debug('Executed Action::PUT. -> %s', get_class($this));
    }
    
    /**
     * DELETEメソッド時に実行される。
     * @access     public
     */
    public function DELETE()
    {
        Samurai_Logger::debug('Executed Action::DELETE. -> %s', get_class($this));
    }
    
    
    
    
    
    /**
     * レンダラーの前に実行される。
     * @access     public
     */
    public function beforeRenderer()
    {
        
    }
}
